// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ds_dbw_msgs:msg/PropulsionInfo.idl
// generated code does not contain a copyright notice
#include "ds_dbw_msgs/msg/detail/propulsion_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
ds_dbw_msgs__msg__PropulsionInfo__init(ds_dbw_msgs__msg__PropulsionInfo * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ds_dbw_msgs__msg__PropulsionInfo__fini(msg);
    return false;
  }
  // propulsion_torque_request
  // propulsion_torque_actual
  // engine_torque_request
  // engine_torque_actual
  // transmission_ratio
  return true;
}

void
ds_dbw_msgs__msg__PropulsionInfo__fini(ds_dbw_msgs__msg__PropulsionInfo * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // propulsion_torque_request
  // propulsion_torque_actual
  // engine_torque_request
  // engine_torque_actual
  // transmission_ratio
}

bool
ds_dbw_msgs__msg__PropulsionInfo__are_equal(const ds_dbw_msgs__msg__PropulsionInfo * lhs, const ds_dbw_msgs__msg__PropulsionInfo * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // propulsion_torque_request
  if (lhs->propulsion_torque_request != rhs->propulsion_torque_request) {
    return false;
  }
  // propulsion_torque_actual
  if (lhs->propulsion_torque_actual != rhs->propulsion_torque_actual) {
    return false;
  }
  // engine_torque_request
  if (lhs->engine_torque_request != rhs->engine_torque_request) {
    return false;
  }
  // engine_torque_actual
  if (lhs->engine_torque_actual != rhs->engine_torque_actual) {
    return false;
  }
  // transmission_ratio
  if (lhs->transmission_ratio != rhs->transmission_ratio) {
    return false;
  }
  return true;
}

bool
ds_dbw_msgs__msg__PropulsionInfo__copy(
  const ds_dbw_msgs__msg__PropulsionInfo * input,
  ds_dbw_msgs__msg__PropulsionInfo * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // propulsion_torque_request
  output->propulsion_torque_request = input->propulsion_torque_request;
  // propulsion_torque_actual
  output->propulsion_torque_actual = input->propulsion_torque_actual;
  // engine_torque_request
  output->engine_torque_request = input->engine_torque_request;
  // engine_torque_actual
  output->engine_torque_actual = input->engine_torque_actual;
  // transmission_ratio
  output->transmission_ratio = input->transmission_ratio;
  return true;
}

ds_dbw_msgs__msg__PropulsionInfo *
ds_dbw_msgs__msg__PropulsionInfo__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__PropulsionInfo * msg = (ds_dbw_msgs__msg__PropulsionInfo *)allocator.allocate(sizeof(ds_dbw_msgs__msg__PropulsionInfo), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ds_dbw_msgs__msg__PropulsionInfo));
  bool success = ds_dbw_msgs__msg__PropulsionInfo__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ds_dbw_msgs__msg__PropulsionInfo__destroy(ds_dbw_msgs__msg__PropulsionInfo * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ds_dbw_msgs__msg__PropulsionInfo__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ds_dbw_msgs__msg__PropulsionInfo__Sequence__init(ds_dbw_msgs__msg__PropulsionInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__PropulsionInfo * data = NULL;

  if (size) {
    data = (ds_dbw_msgs__msg__PropulsionInfo *)allocator.zero_allocate(size, sizeof(ds_dbw_msgs__msg__PropulsionInfo), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ds_dbw_msgs__msg__PropulsionInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ds_dbw_msgs__msg__PropulsionInfo__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ds_dbw_msgs__msg__PropulsionInfo__Sequence__fini(ds_dbw_msgs__msg__PropulsionInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ds_dbw_msgs__msg__PropulsionInfo__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ds_dbw_msgs__msg__PropulsionInfo__Sequence *
ds_dbw_msgs__msg__PropulsionInfo__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__PropulsionInfo__Sequence * array = (ds_dbw_msgs__msg__PropulsionInfo__Sequence *)allocator.allocate(sizeof(ds_dbw_msgs__msg__PropulsionInfo__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ds_dbw_msgs__msg__PropulsionInfo__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ds_dbw_msgs__msg__PropulsionInfo__Sequence__destroy(ds_dbw_msgs__msg__PropulsionInfo__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ds_dbw_msgs__msg__PropulsionInfo__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ds_dbw_msgs__msg__PropulsionInfo__Sequence__are_equal(const ds_dbw_msgs__msg__PropulsionInfo__Sequence * lhs, const ds_dbw_msgs__msg__PropulsionInfo__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ds_dbw_msgs__msg__PropulsionInfo__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ds_dbw_msgs__msg__PropulsionInfo__Sequence__copy(
  const ds_dbw_msgs__msg__PropulsionInfo__Sequence * input,
  ds_dbw_msgs__msg__PropulsionInfo__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ds_dbw_msgs__msg__PropulsionInfo);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ds_dbw_msgs__msg__PropulsionInfo * data =
      (ds_dbw_msgs__msg__PropulsionInfo *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ds_dbw_msgs__msg__PropulsionInfo__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ds_dbw_msgs__msg__PropulsionInfo__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ds_dbw_msgs__msg__PropulsionInfo__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
